<template>
  <div class="contract-front-container">
    <div class="no-print">
      <div
        v-if="isTariffAgreement"
        class="top-info-block"
      >
        Тарифное соглашение к договору {{ contract.parentContractData.number }}
      </div>
      <div
        v-if="(isDraft || !isStatus) && !isTracking && isRole === 'clicar' && !isTariffAgreement"
        class="cols"
      >
        <div class="cols__item">
          <div class="input-group">
            <div class="main-title">Вы Заказчик или Исполнитель?</div>
            <ObControlGroup
              v-if="true"
              :value="currentRole"
              :items="rolesItems"
              theme="light"
              data-qa="changeRole"
              @input="onChangeRole"
              height="slim"
              :disabled="!isDraft || isNotCreator || isExistServices"
            />
          </div>
        </div>
      </div>


      <div class="main-title">
        <span>Номер договора и период действия</span>
        <ObValidateState
            v-if="isDraft"
            :is-valid="isValidNumberAndDates"
        />
      </div>
      <div class="row">
        <div class="col-lg-9 mb20">
          <ObInput
              v-model="contract.originalNumber"
              label="Внешний номер договора"
              property="originalNumber"
              placeholder="Укажите номер"
              data-qa="originalNumber"
              :readonly="!isDraft || isNotCreator || !this.isTitul"
              @input="changeFieldHandler('originalNumber', $event)"
              @blur="saveContractField('originalNumber')"
          />
        </div>
      </div>
      <div class="row center-xs">
        <div class="col-lg-3 col-md-6">
          <ObDatePicker
              :value="contract.originalSignedDate"
              label="Дата подписания"
              placeholder="Укажите"
              :readonly="!isDraft || isNotCreator || !this.isTitul"
              data-qa="originalSignedDate"
              @input="changeFieldHandler('originalSignedDate', $event, true)"
              property="originalSignedDate"
          />
        </div>
        <div class="col-lg-3 col-md-6">
          <ObDatePicker
              :value="contract.fromDate"
              label="Дата начала действия"
              placeholder="Укажите"
              :readonly="!isDraft || isNotCreator"
              data-qa="fromDate"
              @input="changeFieldHandler('fromDate', $event, true)"
              property="fromDate"
          />
        </div>
        <div class="col-lg-3 col-md-6">
          <ObDatePicker
              :value="contract.toDate"
              label="Дата окончания действия"
              :disabled="isTimeless && isDraft"
              :readonly="!isDraft || isNotCreator"
              :placeholder="isTimeless ? '-' : undefined"
              :format="isTimeless ? '' : 'dd.mm.yyyy'"
              data-qa="toDate"
              @input="changeFieldHandler('toDate', $event, true)"
              property="toDate"
          />
        </div>
        <div class="col-lg-3 col-md-6 d-f al-i-c">
          <ObCheckbox
              v-if="!isTariffAgreement || contract.parentContractData.isTimeless"
              v-model="contract.isTimeless"
              label="Бессрочно"
              :disabled="!isDraft || isNotCreator"
              data-qa="isTimeless"
              @change="changeFieldHandler('isTimeless', $event, true)"
          />
        </div>
      </div>
      <div
          v-if="contract.parentContractData && contract.parentContractData.fromDate"
          class="tariff-agreement-dates"
      >
        <ObAlert
            icon="alert"
            hide-close-button
        >
          Период действия тарифного соглашения должен быть в пределах периода действия рамочного договора.<br>
          <strong>
            <template v-if="contract.parentContractData.fromDate">
              {{ contract.parentContractData.fromDate | date }}
            </template>
            <template v-else>
              Не указано
            </template>
            &nbsp;—&nbsp;
            <template v-if="contract.parentContractData.toDate">
              {{ contract.parentContractData.toDate | date }}
            </template>
            <template v-else-if="contract.parentContractData.isTimeless">
              Бессрочно
            </template>
            <template v-else>
              Не указано
            </template>
          </strong>
        </ObAlert>
      </div>

      <div class="cols">
        <!-- Client form -->
        <div class="cols__item">
          <div class="input-group">
            <div class="main-title">
              <span>Заказчик</span>
              <ObValidateState
                v-if="isDoer && isDraft && !isTariffAgreement"
                :is-valid="!isNotSelectClientUser"
              />
            </div>
            <template v-if="isClient || !isDraft || isTariffAgreement">
              <ObInput
                label="Наименование"
                pre-icon="user"
                :value="contract.clientTitle"
                :readonly="true"
                data-qa="customerName"
              />
            </template>
            <template v-else>
              <keep-alive>
                <ObSelect
                  :value="contract.clientUuid"
                  label="Наименование"
                  placeholder="Выберите из списка"
                  :remote-opt="{
                    method: api.contract.getParticipantList,
                    arguments: {
                      type: 'client'
                    }
                  }"
                  :remote-trigger="isDoer"
                  :disabled="!isDraft || isNotCreator || isExistServices || isExistTariffAgreements"
                  :is-standart="true"
                  :is-search="true"
                  :initial-value="getParticipantValue('client')"
                  data-qa="customerName"
                  @selected="onSelectParticipant($event, 'client')"
                />
              </keep-alive>
            </template>
<!--            <ObInput-->
<!--              :value="contract.clientExternalNumber"-->
<!--              label="Ссылочный № договора Заказчика (необязательно)"-->
<!--              placeholder="Укажите номер"-->
<!--              class="mt20"-->
<!--              :readonly="!isDraft || isNotCreator || isTariffAgreement"-->
<!--              data-qa="customerExternalNumber"-->
<!--              @input="changeFieldHandler('clientExternalNumber', $event)"-->
<!--              @blur="saveContractField('clientExternalNumber')"-->
<!--            />-->
          </div>
          <div class="input-group">
            <div class="sub-title">Адреса</div>
            <ObInput
              :value="contract.clientPostAddress"
              label="Почтовый адрес"
              :placeholder="conditionPlaceholder('Укажите адрес', CLIENT_CODE)"
              :readonly="true"
              class="mb20"
              data-qa="customerPostAddress"
            />
            <ObInput
              :value="contract.clientLegalAddress"
              label="Юридический адрес"
              :placeholder="conditionPlaceholder('Укажите адрес', CLIENT_CODE)"
              :readonly="true"
              data-qa="customerLegalAddress"
            />
          </div>
          <div class="input-group">
            <div class="sub-title">
              <span>Подписант</span>
              <ObValidateState
                v-if="isDraft"
                :is-valid="isClientAuthority"
              />
            </div>
            <ObInput
              :value="contract.clientSignerFio"
              :readonly="(!isDraft && !(isNotCreator && isUserClient && isSigning)) || isTariffAgreement"
              label="ФИО подписанта"
              placeholder="Укажите"
              type="word"
              class="mb20"
              data-qa="customerSignerFio"
              @input="changeFieldHandler('clientSignerFio', $event)"
              @blur="saveContractField('clientSignerFio')"
            />
            <template v-if="!isTariffAgreement && (isDraft || !isStatus)">
              <ObRadio
                :model-value="contract.clientAuthoritySource"
                :label="authoritySource.CHARTER.label"
                :valueInput="authoritySource.CHARTER.value"
                :disabled="!isStatus"
                class="mb10"
                data-qa="customerAuthoritySourceCharter"
                @change="changeFieldHandler('clientAuthoritySource', $event, true)"
              />
              <ObRadio
                :model-value="contract.clientAuthoritySource"
                :label="authoritySource.PROCURATORY.label"
                :valueInput="authoritySource.PROCURATORY.value"
                class="mb10"
                :disabled="!isStatus"
                data-qa="customerAuthoritySourceProcuratory"
                @change="changeFieldHandler('clientAuthoritySource', $event, true)"
              />
            </template>
            <template v-else>
              <p>{{ authoritySource[contract.clientAuthoritySource] && authoritySource[contract.clientAuthoritySource].shortLabel }}</p>
            </template>
            <transition name="toggle-height">
              <ObUploader
                v-if="Boolean(contract.clientAuthoritySource)"
                :is-read-only="!isDraft || isTariffAgreement"
                :value="contract.authorityFiles[CLIENT_CODE] || null"
                :multiple="false"
                data-qa="customerAuthoritySourceFiles"
                @change="onUploadFile($event, CLIENT_CODE)"
              />
            </transition>
          </div>
          <div class="input-group">
            <div class="sub-title">
              <span>Ответственный сотрудник</span>
              <ObValidateState
                v-if="isDraft"
                :is-valid="isClientAccountUser"
              />
            </div>
            <ObSelect
              ref="clientCuratorSelect"
              :value="contract.clientCuratorUuid"
              label="Ответственный сотрудник"
              :placeholder="conditionPlaceholder('Выберите из списка', CLIENT_CODE)"
              :disabled="(!isDraft && !(isNotCreator && isUserClient && isSigning)) || isNotSelectClientUser || isTariffAgreement"
              :remote-opt="{
                method: api.contract.getUserListByParticipant,
                arguments: {
                  uuid: contract.clientUuid
                }
              }"
              :remote-trigger="contract.clientUuid"
              :is-standart="true"
              data-qa="customerCurator"
              @input="changeFieldHandler('clientCuratorUuid', $event, true)"
              @selected="selectCuratorHandler($event, CLIENT_CODE)"
            />
          </div>
          <div class="input-group">
            <div class="sub-title">
              <span>Отправлять уведомления Заказчику</span>
              <ObValidateState
                v-if="isDraft"
                :is-valid="isClientNotification"
              />
            </div>
            <div class="checkbox-input">
              <ObCheckbox
                :value="contract.needNotifyClientByMail"
                :disabled="isNotSelectClientUser || !isDraft || isTariffAgreement"
                data-qa="customerNotifyByMail"
                @change="changeFieldHandler('needNotifyClientByMail', $event, true)"
              />
              <ObInput
                :value="contract.clientPostAddress"
                label="Почтовый адрес"
                :placeholder="conditionPlaceholder('Укажите адрес', CLIENT_CODE)"
                :readonly="true"
                data-qa="customerNotifyMail"
              />
            </div>
            <div class="checkbox-input">
              <ObCheckbox
                v-model="contract.needNotifyClientByJurMail"
                :disabled="isNotSelectClientUser || !isDraft || isTariffAgreement"
                data-qa="customerNotifyByJurMail"
                @change="saveContractField('needNotifyClientByJurMail')"
              />
              <ObInput
                :value="contract.clientLegalAddress"
                label="Юридический адрес"
                :placeholder="conditionPlaceholder('Укажите адрес', CLIENT_CODE)"
                :readonly="true"
                data-qa="customerNotifyJurMail"
              />
            </div>
            <div class="checkbox-input">
              <ObCheckbox
                :value="contract.needNotifyClientByEmail"
                :disabled="(!isDraft && (!(isNotCreator && isUserClient && isSigning) || isOnlyClientMailNotification))  || isTariffAgreement"
                data-qa="customerNotifyByEmail"
                @change="changeFieldHandler('needNotifyClientByEmail', $event, true)"
              />
              <ObInput
                :value="contract.clientEmail"
                label="Электронная почта"
                label-info="Электро́нная по́чта (англ. email, e-mail [iˈmeɪl], от англ. electronic mail) — технология и служба по пересылке и получению электронных сообщений (называемых «письма», «электронные письма» или «сообщения») между пользователями компьютерной сети (в том числе — Интернета)[1]."
                placeholder="Укажите e-mail"
                :disabled="!contract.needNotifyClientByEmail"
                :readonly="(!isDraft && !(isNotCreator && isUserClient && isSigning)) || isTariffAgreement"
                property="clientEmail"
                data-qa="customerNotifyEmail"
                @input="changeFieldHandler('clientEmail', $event)"
                @blur="saveContractField('clientEmail')"
              />
            </div>
            <div class="checkbox-input">
              <ObCheckbox
                :value="contract.needNotifyClientByPhone"
                :disabled="!isDraft || isTariffAgreement"
                data-qa="customerNotifyByPhone"
                @change="changeFieldHandler('needNotifyClientByPhone', $event, true)"
              />
              <ObInput
                :value="contract.clientPhone"
                label="СМС на номер телефона"
                :mask="phoneMask"
                :disabled="!contract.needNotifyClientByPhone"
                :readonly="!isDraft || isTariffAgreement"
                property="clientPhone"
                data-qa="customerNotifyPhone"
                @input="changeFieldHandler('clientPhone', $event)"
                @blur="saveContractField('clientPhone')"
              />
            </div>
          </div>
        </div>
        <!-- Doer form -->
        <div class="cols__item">
          <div class="input-group">
            <div class="main-title">
              <span>Исполнитель</span>
              <ObValidateState
                v-if="isClient && isDraft"
                :is-valid="!isNotSelectDoerUser"
              />
            </div>
            <template v-if="isDoer || !isDraft || isTracking || isTariffAgreement">
              <ObInput
                label="Наименование"
                pre-icon="user"
                :value="contract.doerTitle"
                :readonly="true"
                data-qa="executorName"
              />
            </template>
            <template v-else>
              <keep-alive>
                <ObSelect
                  :value="contract.doerUuid"
                  label="Наименование"
                  placeholder="Выберите из списка"
                  :remote-opt="{
                    method: api.contract.getParticipantList,
                    arguments: {
                      type: 'doer'
                    }
                  }"
                  :disabled="!isDraft || isNotCreator || isExistServices || isExistTariffAgreements"
                  :is-standart="true"
                  :is-search="true"
                  :initial-value="getParticipantValue('doer')"
                  data-qa="executorName"
                  @selected="onSelectParticipant($event, 'doer')"
                />
              </keep-alive>
            </template>
<!--            <ObInput-->
<!--              :value="contract.doerExternalNumber"-->
<!--              label="Ссылочный № договора Исполнителя (необязательно)"-->
<!--              placeholder="Укажите номер"-->
<!--              class="mt20"-->
<!--              :readonly="!isDraft || isNotCreator || isTariffAgreement"-->
<!--              data-qa="executorExternalNumber"-->
<!--              @input="changeFieldHandler('doerExternalNumber', $event)"-->
<!--              @blur="saveContractField('doerExternalNumber')"-->
<!--            />-->
          </div>
          <div class="input-group">
            <div class="sub-title">Адреса</div>
            <ObInput
              :value="contract.doerPostAddress"
              label="Почтовый адрес"
              :placeholder="conditionPlaceholder('Укажите адрес', DOER_CODE)"
              :readonly="true"
              class="mb20"
              data-qa="executorPostAddress"
            />
            <ObInput
              :value="contract.doerLegalAddress"
              label="Юридический адрес"
              :placeholder="conditionPlaceholder('Укажите адрес', DOER_CODE)"
              :readonly="true"
              data-qa="executorLegalAddress"
            />
          </div>
          <div class="input-group">
            <div class="sub-title">
              <span>Подписант</span>
              <ObValidateState
                v-if="isDraft"
                :is-valid="isDoerAuthority"
              />
            </div>
            <ObInput
              :value="contract.doerSignerFio"
              label="ФИО подписанта"
              placeholder="Укажите"
              type="word"
              class="mb20"
              :readonly="(!isDraft && !(isNotCreator && isUserDoer && isSigning)) || isTariffAgreement"
              data-qa="executorSignerFio"
              @input="changeFieldHandler('doerSignerFio', $event)"
              @blur="saveContractField('doerSignerFio')"
            />
            <template v-if="!isTariffAgreement && (isDraft || !isStatus)">
              <ObRadio
                :model-value="contract.doerAuthoritySource"
                :label="authoritySource.CHARTER.label"
                :valueInput="authoritySource.CHARTER.value"
                :disabled="!isStatus"
                class="mb10"
                data-qa="executorAuthoritySourceCharter"
                @change="changeFieldHandler('doerAuthoritySource', $event, true)"
              />
              <ObRadio
                :model-value="contract.doerAuthoritySource"
                :label="authoritySource.PROCURATORY.label"
                :valueInput="authoritySource.PROCURATORY.value"
                :disabled="!isStatus"
                class="mb10"
                data-qa="executorAuthoritySourceProcuratory"
                @change="changeFieldHandler('doerAuthoritySource', $event, true)"
              />
            </template>
            <template v-else>
              <p>{{ authoritySource[contract.doerAuthoritySource] && authoritySource[contract.doerAuthoritySource].shortLabel }}</p>
            </template>
            <transition name="toggle-height">
              <ObUploader
                v-if="Boolean(contract.doerAuthoritySource)"
                :is-read-only="!isDraft || isTariffAgreement"
                :value="contract.authorityFiles[DOER_CODE] || null"
                :multiple="false"
                data-qa="executorAuthoritySourceFiles"
                @change="onUploadFile($event, DOER_CODE)"
              />
            </transition>
          </div>
          <div class="input-group">
            <div class="sub-title">
              <span>Ответственный сотрудник</span>
              <ObValidateState
                v-if="isDraft"
                :is-valid="isDoerAccountUser"
              />
            </div>
            <ObSelect
              ref="doerCuratorSelect"
              :value="contract.doerCuratorUuid"
              label="Ответственный сотрудник"
              :placeholder="conditionPlaceholder('Выберите из списка', DOER_CODE)"
              :disabled="(!isDraft && !(isNotCreator && isUserDoer && isSigning)) || isNotSelectDoerUser || isTariffAgreement"
              :remote-opt="{
                method: api.contract.getUserListByParticipant,
                arguments: {
                  uuid: contract.doerUuid
                }
              }"
              :remote-trigger="contract.doerUuid"
              :is-standart="true"
              data-qa="executorCurator"
              @input="changeFieldHandler('doerCuratorUuid', $event)"
              @selected="selectCuratorHandler($event, DOER_CODE)"
            />
          </div>
          <div class="input-group">
            <div class="sub-title">
              <span>Отправлять уведомления Исполнителю</span>
              <ObValidateState
                v-if="isDraft"
                :is-valid="isDoerNotification"
              />
            </div>
            <div class="checkbox-input">
              <ObCheckbox
                v-model="contract.needNotifyDoerByMail"
                :disabled="isNotSelectDoerUser || !isDraft || isTariffAgreement"
                data-qa="executorNotifyByMail"
                @change="changeFieldHandler('needNotifyDoerByMail', $event, true)"
              />
              <ObInput
                :value="contract.doerPostAddress"
                label="Почтовый адрес"
                :placeholder="conditionPlaceholder('Укажите адрес', DOER_CODE)"
                :readonly="true"
                data-qa="executorNotifyMail"
              />
            </div>
            <div class="checkbox-input">
              <ObCheckbox
                :value="contract.needNotifyDoerByJurMail"
                :disabled="isNotSelectDoerUser || !isDraft || isTariffAgreement"
                data-qa="executorNotifyByJurMail"
                @change="changeFieldHandler('needNotifyDoerByJurMail', $event, true)"
              />
              <ObInput
                v-model="contract.doerLegalAddress"
                label="Юридический адрес"
                :placeholder="conditionPlaceholder('Укажите адрес', DOER_CODE)"
                :readonly="true"
                data-qa="executorNotifyJurMail"
              />
            </div>
            <div class="checkbox-input">
              <ObCheckbox
                :value="contract.needNotifyDoerByEmail"
                :disabled="(!isDraft && (!(isNotCreator && isUserDoer && isSigning) || isOnlyDoerMailNotification)) || isTariffAgreement"
                data-qa="executorNotifyByEmail"
                @change="changeFieldHandler('needNotifyDoerByEmail', $event, true)"
              />
              <ObInput
                v-model="contract.doerEmail"
                label="Электронная почта"
                label-info="Электро́нная по́чта (англ. email, e-mail [iˈmeɪl], от англ. electronic mail) — технология и служба по пересылке и получению электронных сообщений (называемых «письма», «электронные письма» или «сообщения») между пользователями компьютерной сети (в том числе — Интернета)[1]."
                placeholder="Укажите e-mail"
                :disabled="!contract.needNotifyDoerByEmail"
                :readonly="(!isDraft && !(isNotCreator && isUserDoer && isSigning)) || isTariffAgreement"
                property="doerEmail"
                data-qa="executorNotifyEmail"
                @input="changeFieldHandler('doerEmail', $event)"
                @blur="saveContractField('doerEmail')"
              />
            </div>
            <div class="checkbox-input">
              <ObCheckbox
                :value="contract.needNotifyDoerByPhone"
                :disabled="!isDraft || isTariffAgreement"
                data-qa="executorNotifyByPhone"
                @change="changeFieldHandler('needNotifyDoerByPhone', $event, true)"
              />
              <ObInput
                v-model="contract.doerPhone"
                label="СМС на номер телефона"
                :mask="phoneMask"
                :disabled="!contract.needNotifyDoerByPhone"
                :readonly="!isDraft || isTariffAgreement"
                property="doerPhone"
                data-qa="executorNotifyPhone"
                @input="changeFieldHandler('doerPhone', $event)"
                @blur="saveContractField('doerPhone')"
              />
            </div>
          </div>
        </div>
      </div>
      <div class="col-single">
        <template v-if="isDraft || (contract.files && contract.files.length)">
          <div class="main-title mt30" :class="!isDraft && 'mb0'">Документ-первоисточник</div>
          <div class="row">
            <div class="col-xs-12">
              <p v-if="isDraft" class="mb10">Вы можете прикрепить документы, на основании которого создан электронный договор</p>
              <ObUploader
                :is-read-only="!isDraft"
                :value="contract.files || null"
                :multiple="true"
                :is-detail-emit="true"
                :download-url="'/oboz2-contract-contracts-crud/v1/contract/file'"
                data-qa="attachFiles"
                @change="onUploadOtherFiles"
              />
            </div>
          </div>
        </template>
      </div>
    </div>
  </div>
</template>

<script>
  import { mapActions, mapMutations, mapGetters } from 'vuex'
  import ContractDetailMixin from '@/components/Contract/detail/contract-detail-mixin'
  import api from '@/api'
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObUploader from 'common-components/src/obComponents/obUploader'
  import ObRadio from 'common-components/src/obComponents/obRadio'
  import ObSelect from 'common-components/src/obComponents/obSelect'
  import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
  import ObDatePicker from 'common-components/src/obComponents/obDatePickerConstructor'
  import ObAlert from 'common-components/src/obComponents/obAlert'
  import ObControlGroup from 'common-components/src/obComponents/obControlGroup'
  import ObValidateState from '@/components/Contract/detail/obValidateState'
  import {tokenData} from '@/utils/jwt'

  export default {
    name: 'ContractDetailFrontPage',
    mixins: [
      ContractDetailMixin
    ],
    components: {
      ObInput,
      ObUploader,
      ObRadio,
      ObCheckbox,
      ObDatePicker,
      ObControlGroup,
      ObSelect,
      ObValidateState,
      ObAlert
    },
    data() {
      return {
        api,
        phoneMask: '+7 (999) 999-99-99',
        authoritySource: {
          CHARTER: {
            label: 'Действует на основании Устава и приказа о Назначении (прикрепите скан)',
            shortLabel: 'Действует на основании Устава и приказа о Назначении',
            value: 'CHARTER'
          },
          PROCURATORY: {
            label: 'Действует по доверенности (прикрепите скан)',
            shortLabel: 'Действует по доверенности',
            value: 'PROCURATORY'
          }
        }
      }
    },
    computed: {
      ...mapGetters({
        isRole: 'user/role',
        isTariffAgreement: 'contract/isTariffAgreement'
      }),
      isClient () {
        return this.currentRole === this.CLIENT_CODE
      },
      isDoer () {
        return this.currentRole === this.DOER_CODE
      }
    },
    methods: {
      ...mapActions({
        reverseContractData: 'contract/reverseContractData',
        postContractFiles: 'contract/postFiles',
        deleteContractFiles: 'contract/deleteFiles',
      }),
      ...mapMutations({
        setCurrentRole: 'contract/setCurrentRole',
        setContractData: 'contract/setContractData',
      }),
      onChangeRole (role) {
        this.setCurrentRole(role)
        this.reverseContractData()
      },
      onSelectParticipant (data, type) {
        this.setContractData({
          [type + 'Uuid']: data.uuid,
          [type + 'Title']: data.title
        })
        this.changeFieldHandler(type + 'Uuid', data.uuid)
      },
      async onUploadFile(data, userTypeCode) {
        let saveData = {}
        data = data[0]
        let mapKeys = {
          [this.CLIENT_CODE]: 'clientProcuratoryFileUuid',
          [this.DOER_CODE]: 'doerProcuratoryFileUuid',
        }

        if (!data) {
          saveData[mapKeys[userTypeCode]] = null
          this.setContractData(saveData)
          this.saveContract()
          return
        }

        const jsonData = {
          filename: data.file.name,
          participant_uuid: tokenData.contractor_uuid,
          is_personal_info: true
        }

        const form = new FormData()
        form.append('jsonData', JSON.stringify(jsonData))
        form.append('file', data.file)

        try {
          await api.taskMonitor.postTaskFile(data.uuid, form)
          saveData[mapKeys[userTypeCode]] = data.uuid
          this.setContractData(saveData)
          this.saveContract()
        } catch (e) {
          console.log(e)
        }
      },
      async onUploadOtherFiles ({ files, added, deleted } = {}) {
        if (!files) return

        try {
          if (added) {
            await this.postContractFiles({ files: added, contract_uuid: this.contractId })
          }
          if (deleted) {
            await this.deleteContractFiles({ uuids: [ deleted ] })
          }
        } catch (e) {
          console.log(e)
        }
      },
      selectCuratorHandler (data, userTypeCode) {
        this.$nextTick(() => {
          this.changeFieldHandler(userTypeCode + 'Email', data.email, true)
        })
      },
      getParticipantValue (type) {
        const existValue = Boolean(this.contract[type + 'Uuid'])
        let result = []

        if (existValue) {
          result.push({
            title: this.contract[type + 'Title'],
            uuid: this.contract[type + 'Uuid']
          })
        }

        return result
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .contract-front-container {
    position: relative;
    padding: 20px 0 42px 20px;

    .cols {
      display: flex;
      justify-content: flex-start;

      &__item {
        width: 50%;
        margin-top: 20px;
        padding-right: 101px;
      }
    }

    .col-single {
      padding-right: 20px;
    }

    .input-group {
      margin-bottom: 30px;
    }

    .main-title, .sub-title {
      display: flex;
      justify-content: flex-start;
      align-items: center;
      margin-bottom: 10px;

      .ob-validate-state-container {
        margin-left: 5px;
      }
    }

    .main-title {
      @include font-mixin(20px, 28px, 600, $color-text-base, 0.4px);
    }

    .sub-title {
      margin-bottom: 10px;
      @include font-mixin(16px, 24px, 600, $color-text-base, 0.4px);
    }

    .termination-input {
      width: 125px;
      margin-left: 38px;
    }
  }
  .no-print{
    display: block;
    @media print {
      display: none;
    }
  }
</style>

<style lang="scss">
  .contract-front-container {
    .mb20 {
      margin-bottom: 20px;
    }

    .mt20 {
      margin-top: 20px;
    }

    .mt30 {
      margin-top: 30px;
    }

    .mb10 {
      margin-bottom: 10px;
    }

    .mb0 {
      margin-bottom: 0!important;
    }

    .checkbox-input {
      display: flex;
      justify-content: flex-start;
      align-items: center;

      & + .checkbox-input {
        margin-top: 10px;
      }

      .ob-checkbox-container {
        flex-shrink: 0;
      }

      .ob-input-container {
        flex-grow: 2;
        margin-left: 10px;
      }
    }

    .top-info-block {
      margin-top: 20px;
      margin-bottom: 20px;
      font-size: 16px;
      line-height: 20px;
      color: $color-grey-label;
    }

    .tariff-agreement-dates {
      margin-top: 20px;
      margin-bottom: -10px;
      padding-right: 100px;
    }
  }

  .uploader__chip {
    display: inline-flex;
    align-items: center;
    justify-content: space-between;
    padding: 10px;
    border-radius: 25px;
    background: $lavender;
    margin-right: 13px;
    margin-top: 10px;
    height: 30px;
    cursor: pointer;
    &-text {
      font-family: "Roboto", sans-serif;
      font-style: normal;
      font-weight: normal;
      font-size: 14px;
      line-height: 14px;
      text-align: center;
      color: $color-text-base;
      margin-right: 6px;
      position: relative;
    }
    &-icon {
      font-size: 8px;
      font-weight: bold;
      &:hover {
        opacity: 0.7;
      }
    }
  }

</style>
